<template>
  <div class="pagination-container">
    <el-pagination
      :background="background"
      v-model:current-page="currentPage"
      v-model:page-size="pageSize"
      :layout="layout"
      :page-sizes="pageSizes"
      :pager-count="pagerCount"
      :total="total"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange" />
  </div>
</template>

<script setup>
import { scrollTo } from "@/utils/scroll-to"

const props = defineProps({
  total: {
    required: true,
    type: Number,
  },
  page: {
    type: Number,
    default: 1,
  },
  limit: {
    type: Number,
    default: 20,
  },
  pageSizes: {
    type: Array,
    default() {
      return [10, 20, 30, 50]
    },
  },
  // 移动端页码按钮的数量端默认值5
  pagerCount: {
    type: Number,
    default: document.body.clientWidth < 992 ? 5 : 7,
  },
  layout: {
    type: String,
    default: "prev, pager, next",
  },
  background: {
    type: Boolean,
    default: true,
  },
  autoScroll: {
    type: Boolean,
    default: true,
  },
  hidden: {
    type: Boolean,
    default: false,
  },
})

const emit = defineEmits()
const currentPage = computed({
  get() {
    return props.page
  },
  set(val) {
    emit("update:page", val)
  },
})
const pageSize = computed({
  get() {
    return props.limit
  },
  set(val) {
    emit("update:limit", val)
  },
})
function handleSizeChange(val) {
  if (currentPage.value * val > props.total) {
    currentPage.value = 1
  }
  emit("pagination", { page: currentPage.value, limit: val })
  if (props.autoScroll) {
    scrollTo(0, 800)
  }
}
function handleCurrentChange(val) {
  emit("pagination", { page: val, limit: pageSize.value })
  if (props.autoScroll) {
    scrollTo(0, 800)
  }
}
</script>

<style lang="scss" scoped>
.pagination-container {
  display: flex;
  justify-content: center;
  margin-top: 17px;
  background-color: transparent !important;
}
/* 自定义样式 */
::v-deep .el-pagination,
::v-deep .el-pagination__total,
::v-deep .el-pagination__jump,
::v-deep .el-pager li.btn-quicknext,
::v-deep .el-select-dropdown__item {
  color: #fff !important;
}
::v-deep .el-pagination .btn-next,
::v-deep .el-pagination .btn-prev {
  background: center center no-repeat rgba(0, 0, 0, 0.3) !important;
  color: #fff !important;
}
::v-deep .el-pager li {
  background: rgba(0, 0, 0, 0.3) !important;
}
::v-deep .el-pager .is-active {
  background: rgba(76, 123, 208) !important;
}
::v-deep .el-pager .number {
  color: #fff !important;
}
::v-deep .el-pager .more {
  color: #fff !important;
}
</style>
